/*
 * Digital output pattern for alarm alert
 */
void alarmAlert() {

  //Pattern duration: 10secs
  unsigned long rst = 10000;
  //Invert output every second
  unsigned long interval = 1000;

  //Initialize pattern
  if (initMs_alarm == 0) { 
    Debugln("DEBUG: Alarm alert activated");
    initMs_alarm = millis(); 
    opState = HIGH; 
    digitalWrite(OUTPIN, opState);
  }

  //Get current millis
  unsigned long currentMillis = millis();

  //If interval has been exceded invert output
  if (currentMillis - prevMs_alarm >= interval) {
    // save the last time you blinked the LED
    prevMs_alarm = currentMillis;

    // if the LED is off turn it on and vice-versa:
    if (opState == LOW) {
      opState = HIGH;
    } else {
      opState = LOW;
    }

    // set the LED with the ledState of the variable:
    digitalWrite(OUTPIN, opState);
  }

  //If pattern duration has been exceded finalize pattern
  if (currentMillis - initMs_alarm >= rst) {
    _alarm = false;
    initMs_alarm = 0;
    opState = LOW; 
    digitalWrite(OUTPIN, opState);
    Debugln("DEBUG: Stop alarm alert");
  } 
}

/*
 * Digital output pattern for baby alert
 */
void babyAlert() {

  //Pattern duration: 6secs
  unsigned long rst = 6000;
  //Invert output every second
  unsigned long interval = 1000;

  //Initialize pattern
  if (initMs_baby == 0) { 
    Debugln("DEBUG: Baby alert activated");
    initMs_baby = millis();
    opState = HIGH; 
    digitalWrite(OUTPIN, opState); 
  }

  //Get current millis
  unsigned long currentMillis = millis();

  //If interval has been exceded invert output
  if (currentMillis - prevMs_baby >= interval) {
    // save the last time you blinked the LED
    prevMs_baby = currentMillis;

    // if the LED is off turn it on and vice-versa:
    if (opState == LOW) {
      opState = HIGH;
    } else {
      opState = LOW;
    }

    // set the LED with the ledState of the variable:
    digitalWrite(OUTPIN, opState);
  }

  //If pattern duration has been exceded finalize pattern
  if (currentMillis - initMs_baby >= rst) {
    _baby = false;
    initMs_baby = 0;
    opState = LOW; 
    digitalWrite(OUTPIN, opState);
    Debugln("DEBUG: Stop baby alert");
  }
}

/*
 * Digital output pattern for door 1 alert
 */
void door1Alert() {
  
  unsigned long rst = 6000;
  unsigned long interval1 = 2000;
  unsigned long interval2 = 1000;

  if (initMs_door1 == 0) { 
    Debugln("DEBUG: Door 1 alert activated");
    initMs_door1 = millis();
    opState = HIGH; 
    digitalWrite(OUTPIN, opState);
  }
  
  unsigned long currentMillis = millis();

  if (opState == LOW) {
    if (currentMillis - prevMs_door1 >= interval2) {
      // save the last time you blinked the LED
      prevMs_door1 = currentMillis;
  
      opState = HIGH;
        
      // set the LED with the ledState of the variable:
      digitalWrite(OUTPIN, opState);
    }
  } else {
    if (currentMillis - prevMs_door1 >= interval1) {
      // save the last time you blinked the LED
      prevMs_door1 = currentMillis;
  
      opState = LOW;
        
      // set the LED with the ledState of the variable:
      digitalWrite(OUTPIN, opState);
    }    
  }

  //If pattern duration has been exceded finalize pattern
  if (currentMillis - initMs_door1 >= rst) {
    _door1 = false;
    initMs_door1 = 0;
    opState = LOW; 
    digitalWrite(OUTPIN, opState);
    Debugln("DEBUG: Stop door 1 alert");
  }
}

/*
 * Digital output pattern for door 2 alert
 */
void door2Alert() {
  
  unsigned long rst = 6000;
  unsigned long interval1 = 2000;
  unsigned long interval2 = 1000;

  if (initMs_door2 == 0) { 
    Debugln("DEBUG: Door 2 alert activated");
    initMs_door2 = millis();
    opState = HIGH; 
    digitalWrite(OUTPIN, opState);
  }
  
  unsigned long currentMillis = millis();

  if (opState == LOW) {
    if (currentMillis - prevMs_door2 >= interval1) {
      // save the last time you blinked the LED
      prevMs_door2 = currentMillis;
  
      opState = HIGH;
        
      // set the LED with the ledState of the variable:
      digitalWrite(OUTPIN, opState);
    }
  } else {
    if (currentMillis - prevMs_door2 >= interval2) {
      // save the last time you blinked the LED
      prevMs_door2 = currentMillis;
  
      opState = LOW;
        
      // set the LED with the ledState of the variable:
      digitalWrite(OUTPIN, opState);
    }    
  }

  //If pattern duration has been exceded finalize pattern
  if (currentMillis - initMs_door2 >= rst) {
    _door2 = false;
    initMs_door2 = 0;
    opState = LOW; 
    digitalWrite(OUTPIN, opState);
    Debugln("DEBUG: Stop door 2 alert");
  }
}

/*
 * Digital output pattern for telephone alert
 */
void telephoneAlert() {
  
  unsigned long rst = 8000;
  unsigned long interval1 = 500;
  unsigned long interval2 = 2000;

  if (initMs_telephone == 0) { 
    Debugln("DEBUG: Telephone alert activated");
    initMs_telephone = millis();
    opState = HIGH; 
    digitalWrite(OUTPIN, opState);
    _count += 1;
  }
  
  unsigned long currentMillis = millis();

  if (_count == 5 || _count == 11) {
    
    if (currentMillis - prevMs_telephone >= interval2) {
      // save the last time you blinked the LED
      prevMs_telephone = currentMillis;

      _count += 1;
  
      // if the LED is off turn it on and vice-versa:
      if (opState == LOW) {
        opState = HIGH;
      } else {
        opState = LOW;
      }
    }
    
    // set the LED with the ledState of the variable:
    digitalWrite(OUTPIN, opState);
    
  } else {
    if (currentMillis - prevMs_telephone >= interval1) {
      // save the last time you blinked the LED
      prevMs_telephone = currentMillis;

      _count += 1;
  
      // if the LED is off turn it on and vice-versa:
      if (opState == LOW) {
        opState = HIGH;
      } else {
        opState = LOW;
      }
    }

    // set the LED with the ledState of the variable:
    digitalWrite(OUTPIN, opState);
    
  }

  //If pattern duration has been exceded finalize pattern
  if (currentMillis - initMs_telephone >= rst) {
    _telephone = false;
    _count = 0;
    initMs_telephone = 0;
    opState = LOW; 
    digitalWrite(OUTPIN, opState);
    Debugln("DEBUG: Stop telephone alert");
  }
}
