/**
 * 
 */

var hostname = "AUDITIVASSIST-PI";
var port = "3001";
var path = "/ws"
var client = null;
var topic = "AUDITIVASSIST/#";

function connect() {
	
	console.log("Connecting to " + hostname + " on port " + port + "...");

	// Create a client instance
	client = new Paho.Client(hostname, Number(port), path, "AUDITIVASSIST-PI");

	// set callback handlers
	client.onConnectionLost = onConnectionLost;
	client.onMessageArrived = onMessageArrived;

	// connect the client
	client.connect({onSuccess:onConnect});
}

// called when the client connects
function onConnect() {
  // Once a connection has been made, make a subscription and send a message.
  console.log("onConnect");
  client.subscribe(topic);
}

// called when the client loses its connection
function onConnectionLost(responseObject) {
  if (responseObject.errorCode !== 0) {
    console.log("onConnectionLost:"+responseObject.errorMessage);
  }
}

// called when a message arrives
function onMessageArrived(message) {
  console.log("onMessageArrived:"+message.payloadString);
  
  var mList = document.getElementById("mList");
  var date = new Date();
  var timeString = date.toUTCString();
  var logMessage = timeString + " - " + message.payloadString;
  mList.innerHTML += logMessage + "&#10;";
  
}

function discoverDevices() {
	  var message = "DEVICES";
	  message = new Paho.Message(message);
	  message.destinationName = "AUDITIVASSIST";
	  client.send(message);
}

function sendALARMmsg() {
	  var message = "ALARM";
	  message = new Paho.Message(message);
	  message.destinationName = "AUDITIVASSIST";
	  client.send(message);
}

function sendBABYmsg() {
	  var message = "BABY";
	  message = new Paho.Message(message);
	  message.destinationName = "AUDITIVASSIST";
	  client.send(message);
}

function sendDOOR1msg() {
	  var message = "DOOR1";
	  message = new Paho.Message(message);
	  message.destinationName = "AUDITIVASSIST";
	  client.send(message);
}

function sendDOOR2msg() {
	  var message = "DOOR2";
	  message = new Paho.Message(message);
	  message.destinationName = "AUDITIVASSIST";
	  client.send(message);
}

function sendTELmsg() {
	  var message = "TELEPHONE";
	  message = new Paho.Message(message);
	  message.destinationName = "AUDITIVASSIST";
	  client.send(message);
}